/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Action: a wrapper class to handle actions

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Action.h,v 1.12.4.1 2007/06/06 14:03:13 adorigo Exp $
*/

#ifndef __GLITE_CE_MONITOR_CLIENT_ACTION_H__
#define __GLITE_CE_MONITOR_CLIENT_ACTION_H__

#include "glite/ce/monitor-client-api-c/monitor_client_CEMON_CLIENTStub.h"
#include "glite/ce/monitor-client-api-c/Parameter.h"
#include "glite/ce/monitor-client-api-c/Property.h"
#include <string>

#define ACTION monitortypes__Action

class CEEvent;
class CESubscription;
class Policy;
class CEInfo;

class ActionW : public ACTION {

/*   friend class CEEvent; */
/*   friend class CEInfo; */
/*   friend class CESubscription; */
/*   friend class Policy; */
  
  ActionW& operator=(const ActionW&) { return *this; }
  ActionW& operator=(const ACTION&) { return *this; }
  ActionW(const ACTION&) {}
  
 protected:
 
  void init(const ActionW&);

 public:
  ActionW(const std::string& Name, const std::string& type, const bool doActionWhenQueryIs);
  ActionW(const ActionW&);

  virtual ~ActionW(void);

  std::string  getActionName(void) const;
  std::string  getActionType(void) const;
  bool         getPerformAction(void) const;
  int          addParameter(ParameterW*);
  int          getNumberOfParameters(void) const;
  int          getNumberOfProperties(void) const;
  ParameterW*  getParameterAt(const int&) const;
  PropertyW*   getPropertyAt(const int&) const;
  //std::string  getJarPath(void) const;
  std::string  getActionID(void) const;
  void         print(void) const;
};

#endif
