/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        AuthenticationException: a C++ Exception related to "AuthenticationFault" response of CEMon
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: AuthenticationException.h,v 1.9 2005/12/19 16:20:27 adorigo Exp $
*/


#ifndef __GLITE_CE_MONITOR_CLIENT_AUTHNEXCEPTION_H__
#define __GLITE_CE_MONITOR_CLIENT_AUTHNEXCEPTION_H__

#include "glite/ce/monitor-client-api-c/CEException.h"

class AuthenticationException : public CEException
{
 public:
  AuthenticationException(const std::string& methodname, 
			  const time_t& tstamp, 
			  const std::string& errorcode, 
			  const std::string& desc, 
			  const std::string& faultcause) 
    : CEException(methodname, tstamp, errorcode, desc, faultcause) {}
  AuthenticationException() {}
};

#endif
