/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Topic: a class to handle topic

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Topic.h,v 1.11.4.3 2007/06/06 14:03:13 adorigo Exp $
*/

#ifndef __GLITE_CE_MONITOR_CLIENT_TOPIC_H__
#define __GLITE_CE_MONITOR_CLIENT_TOPIC_H__

#include "glite/ce/monitor-client-api-c/monitor_client_CEMON_CLIENTStub.h"
#include "glite/ce/monitor-client-api-c/Dialect.h"
#include <string>

#define TOPIC monitortypes__Topic

class CEEvent;
class CESubscription;
class CETopics;

class Topic : public TOPIC {

/*   friend class CEEvent; */
/*   friend class CEInfo; */
/*   friend class CESubscription; */
/*   friend class CETopics; */
/*   friend class CEConsumer; */
/*   friend class CEConsumerP; */

  Topic& operator=(const Topic&) { return *this; }
  Topic& operator=(const TOPIC&) { return *this; }
  Topic(const TOPIC&) {}

 protected:
  

 public:
  Topic(const std::string&);
  Topic(const Topic&);

  virtual ~Topic();

  int addDialect(DialectW*);
  DialectW* getDialectAt(const int&);
  int getNumOfDialects(void) const;
  std::vector<DialectW*> getDialects(void) const;
  void print(void) const;
};

#endif
